#!/bin/bash
source oat_function
LOG_DIR=/var/log/oat-client
CLIENT_DIR=/usr/share/oat-client
SYSD=/etc/systemd/system

[[ ! -e $SYSD/oat-client.service ]] && systemctl enable oat-client.service

linkJar "/usr/share/oat-client/lib"

if [ ! -e /etc/oat-client/OATprovisioner.properties -o ! \
       -e /etc/oat-client/OAT.properties ];then
    if [ $# -lt 1 ];then
      bash OAT_client.sh
    else
      [[ -e /etc/oat-client/OAT.properties ]] && \
            rm -f /etc/oat-client/OAT.properties 
      [[ -e /etc/oat-client/OATprovisioner.properties ]] && \
            rm -f /etc/oat-client/OATprovisioner.properties
      bash OAT_client.sh "$1"
    fi
fi

/usr/bin/NIARL_TPM_Module -mode 14 -owner_auth 1111111111111111111111111111111111111111 -cred_type EC

(
cd $CLIENT_DIR
export provclasspath=".:./lib/activation.jar:./lib/axis.jar:./lib/bcprov-jdk15-141.jar:./lib/commons-discovery-0.2.jar:./lib/commons-logging-1.0.4.jar:./lib/FastInfoset.jar:./lib/HisPrivacyCAWebServices-client.jar:./lib/HisPrivacyCAWebServices2-client.jar:./lib/HisWebServices-client.jar:./lib/http.jar:./lib/jaxb-api.jar:./lib/jaxb-impl.jar:./lib/jaxb-xjc.jar:./lib/jaxrpc.jar:./lib/jaxws-api.jar:./lib/jaxws-rt.jar:./lib/jaxws-tools.jar:./lib/jsr173_api.jar:./lib/jsr181-api.jar:./lib/jsr250-api.jar:./lib/mail.jar:./lib/mimepull.jar:./lib/PrivacyCA.jar:./lib/resolver.jar:./lib/saaj-api.jar:./lib/saaj-impl.jar:./lib/SALlib_hibernate3.jar:./lib/stax-ex.jar:./lib/xmlstreambuffer.jar:./lib/TSSCoreService.jar:./lib/woodstox.jar:./lib/wsdl4j-1.5.1.jar:./lib/istack-commons-runtime.jar:./lib/txw2.jar:./lib/xml-resolver.jar:./lib/glassfish-gmbal.jar:./lib/glassfish-policy.jar:./lib/glassfish-pfl-tf.jar:./lib/glassfish-pfl-basic.jar:./lib/glassfish-management-api.jar:./lib/glassfish-ha-api.jar"

java -cp $provclasspath gov.niarl.his.privacyca.HisTpmProvisioner
ret=$?
if [ $ret == 0 ] ; then
    echo "Successfully initialized TPM" 
else
    echo "Failed to initialize the TPM, error $ret" 
fi

java -cp $provclasspath gov.niarl.his.privacyca.HisIdentityProvisioner
ret=$?
if [ $ret == 0 ]; then
    echo "Successfully received AIC from Privacy CA" 
else
    echo "Failed to receive AIC from Privacy CA, error $ret" 
fi

java -cp $provclasspath gov.niarl.his.privacyca.HisRegisterIdentity
ret=$?
if [ $ret == 0 ]; then
    echo "Successfully registered identity with appraiser" 
else
    echo "Failed to register identity with appraiser, error $ret" 
fi
)
